#ifndef CAMPSHOPITEM_H
#define CAMPSHOPITEM_H

#include <shopitem.h>

class CampShopItem : public IShopItem
{
public:
    explicit CampShopItem(QObject *parent = nullptr);

    // IShopItem interface
public:
    long id() const override;
    QString name() override;
    QString shortName() override;
    QDecDouble unitPrice() override;
    Enums::VatType vatType() override;
    QString pluginId() const override;

    // ShopItem interface
public:
    QString code() override;

    void setUnitPrice(const QDecDouble &unitPrice);
    void setVatType(const Enums::VatType &vatType);
    void setId(long id);

private:
    long m_id;
    QDecDouble m_unitPrice;
    Enums::VatType m_vatType;
};

typedef QSharedPointer<CampShopItem> CampShopItemPtr;

#endif // CAMPSHOPITEM_H
