#ifndef PERSONPRICE_H
#define PERSONPRICE_H

#include <QObject>
#include <QDecDouble.hh>

#include "../camp_global.h"

class PersonPrice : public QObject
{
    Q_OBJECT

    QX_REGISTER_FRIEND_CLASS(PersonPrice)
    Q_PROPERTY(QString description READ description WRITE setDescription)
    Q_PROPERTY(int fromAge READ fromAge WRITE setFromAge)
    Q_PROPERTY(int toAge READ toAge WRITE setToAge)
    Q_PROPERTY(QDecDouble price READ price WRITE setPrice)
    Q_PROPERTY(bool active READ active WRITE setActive)

public:
    explicit PersonPrice(QObject *parent = 0);

    long id() const;
    void setId(long id);

    QString description() const;
    void setDescription(const QString &description);

    int fromAge() const;
    void setFromAge(int fromAge);

    int toAge() const;
    void setToAge(int toAge);

    QDecDouble price() const;
    void setPrice(QDecDouble price);

    bool active() const;
    void setActive(bool active);

private:
    long m_id;
    QString m_description;
    int m_fromAge;
    int m_toAge;
    int m_price;
    bool m_active;
};

QX_REGISTER_HPP_CAMP(PersonPrice, QObject, 0)

#endif // PERSONPRICE_H
