#ifndef COMMODITYSERVICE_H
#define COMMODITYSERVICE_H

#include <service.h>
#include <isellableservice.h>
#include "data/commodity-data.h"

class CommodityService : public Service<CommodityData>, public ISellableService
{
public:
    CommodityService() = default;

    // ISellableService interface
public:
    QList<IShopItemPtr> shopItems(const QString& category = "") override;
    void addedToVoucher(int itemId, int countAdded) override;
    IShopItemPtr shopItem(int itemId) override;
    ISeller *seller() override;
    QString defaultSort() override;
};

#endif // COMMODITYSERVICE_H
