#ifndef COMMODITYSETTINGSFORM_H
#define COMMODITYSETTINGSFORM_H

#include <QWidget>
#include <formbinder.h>
#include "data/commoditytypedata.h"
#include "settings/commoditysettings.h"
#include <autotablemodel.h>

namespace Ui {
class CommoditySettingsForm;
}

class CommoditySettingsForm : public FormBinder<CommoditySettings>
{
    Q_OBJECT

public:
    explicit CommoditySettingsForm(QWidget *parent = nullptr);
    ~CommoditySettingsForm() override;

private:
    Ui::CommoditySettingsForm *ui;
    AutoTableModel<CommodityTypeData> *m_table;
    QList<QSharedPointer<CommodityTypeData> > m_delCommodityTypes;

    // IForm interface
public:
    void loadEntity() override;

public slots:
    bool saveRecord() override;
private slots:
    void on_addCommodityType_clicked();
    void on_delCommodityType_clicked();
};

#endif // COMMODITYSETTINGSFORM_H
