#ifndef NUMBERSERIES_H
#define NUMBERSERIES_H

#include <QObject>
#include <QSharedPointer>
#include <QStringList>

#include <QxOrm.h>

#include "season.h"
#include "../core_global.h"

class CORESHARED_EXPORT NumberSeries : public QObject
{
    Q_OBJECT
    QX_REGISTER_FRIEND_CLASS(NumberSeries)
    Q_PROPERTY(QString prefix READ prefix WRITE setPrefix)
    Q_PROPERTY(int lastNumber READ lastNumber WRITE setLastNumber)
    Q_PROPERTY(QString pluginName READ pluginName)
    Q_PROPERTY(QString seasonName READ seasonName)
public:
    explicit NumberSeries(QObject *parent = 0);

    long id() const;
    void setId(long id);

    QString prefix() const;
    void setPrefix(const QString &prefix);

    int lastNumber() const;
    void setLastNumber(int lastNumber);

    QString pluginId() const;
    void setPluginId(const QString &pluginId);

    QSharedPointer<Season> season() const;
    void setSeason(const QSharedPointer<Season> &season);

    QString seasonName() const;

    QString pluginName() const;

    Q_INVOKABLE QStringList eagerLoad();

private:
    long m_id;
    QString m_prefix;
    int m_lastNumber;
    QString m_pluginId;
    QSharedPointer<Season> m_season;
};

typedef QSharedPointer<NumberSeries> NumberSeriesPtr;

QX_REGISTER_HPP_CORE(NumberSeries, QObject, 0)

#endif // NUMBERSERIES_H
