#ifndef SYSTEM_H
#define SYSTEM_H

#include "../core_global.h"
#include <QString>

class CORESHARED_EXPORT System
{
    QX_REGISTER_FRIEND_CLASS(System)
public:
    System();
    virtual ~System();

    long id() const;
    void setId(long id);

    QString pluginId() const;

    QString schemaVersion() const;

    QString settings() const;
    void setSettings(const QString &settings);

private:
    long m_id;
    QString m_pluginId;
    QString m_schemaVersion;
    QString m_settings;
};

QX_REGISTER_HPP_CORE(System, qx::trait::no_base_class_defined, 0);

#endif // SYSTEM_H
