#ifndef NUMBERSERIESSERVICE_H
#define NUMBERSERIESSERVICE_H

#include "data/numberseries.h"
#include "data/season.h"
#include "service.h"
#include "core_global.h"

class CORESHARED_EXPORT NumberSeriesService : public Service<NumberSeries>
{
public:
    NumberSeriesService() = default;

    QSharedPointer<NumberSeries> forPluginAndSeason(const QString& pluginId, const QSharedPointer<Season>& season);
    QSharedPointer<NumberSeries> forPlugin(const QString& pluginId);
    QSharedPointer<NumberSeries> nextForPlugin(const QString& pluginId, qx::QxSession* pSession = nullptr);
    QList<QSharedPointer<NumberSeries> > allForSeason(const QSharedPointer<Season>& season);
    QString nextStrForPlugin(const QString& pluginId, qx::QxSession* pSession = nullptr);
};

#endif // NUMBERSERIESSERVICE_H
