#ifndef SHOPITEM_H
#define SHOPITEM_H

#include <QObject>

#include "shop_global.h"
#include "ishopitem.h"

class SHOPSHARED_EXPORT ShopItem : public IShopItem
{
    Q_OBJECT

    Q_PROPERTY(QString code READ code)
    Q_PROPERTY(QString name READ name)
    Q_PROPERTY(QString shortName READ shortName)
    Q_PROPERTY(QDecDouble unitPrice READ unitPrice)
    Q_PROPERTY(Enums::VatType vatType READ vatType)

public:
    explicit ShopItem(QObject *parent = nullptr);

signals:

public slots:

    // IShopItem interface
public:
    long id() const override { return 0; }
    QString code() override { return ""; }
    QString name() override { return ""; }
    QString shortName() override { return ""; }
    QDecDouble unitPrice() override { return {}; }
    Enums::VatType vatType() override { return Enums::NONE; }
    QString pluginId() const override { return ""; }
};

typedef QSharedPointer<ShopItem> ShopItemPtr;

#endif // SHOPITEM_H
